export declare class Type<T> {
    typeName: string;
    _validate: (value: unknown, context: string) => value is T;
    constructor(typeName: string, validate: (value: unknown, context: string) => value is T);
    validate(value: unknown, name?: string): T;
    or<S>(t: Type<S>): Type<T | S>;
}
export declare const Fn: Type<(...args: any[]) => any>;
export declare const String: Type<string>;
export declare const Void: Type<void>;
export declare const Literal: <T>(value: T) => Type<T>;
export declare const ArrayOf: <T>(elementType: Type<T>) => Type<T[]>;
export declare const ObjectKeys: <T extends string>(keys: T[]) => Type<Record<T, unknown>>;
export declare const AnyObject: Type<Record<string, unknown>>;
declare const _default: {
    Fn: Type<(...args: any[]) => any>;
    String: Type<string>;
    Void: Type<void>;
    Literal: <T>(value: T) => Type<T>;
    ArrayOf: <T>(elementType: Type<T>) => Type<T[]>;
    ObjectKeys: <T extends string>(keys: T[]) => Type<Record<T, unknown>>;
    AnyObject: Type<Record<string, unknown>>;
};
export default _default;
